=== debian/changelog ===
aoflagger (3.5.1-1) unstable; urgency=medium

  * New upstream version 3.5.1
  * Rediff patches. Remove patches that ar no longer needed
  * d/copyright: fix license shortname
  * d/u/metadata: fix attribute names
  * Push Standards-Version to 4.7.3, no changes needed
  * Update required gtkmm to 4.0

 -- Ole Streicher <olebole@debian.org>  Sat, 21 Feb 2026 13:32:01 +0100

aoflagger (3.4.0-4) unstable; urgency=medium

  * Team upload.
  * add patch remove-specialized-numeric-funtions.patch
    (Closes: #1115249)

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 18 Dec 2025 18:51:27 +0100

aoflagger (3.4.0-3) unstable; urgency=medium

  * Team upload.
  * 'd/control':
    - Update 'Standards-Version' to 4.7.0, no changes required.
    - Update 'Homepage' to current.
  * 'd/copyright':
    - Add 'Files: debian/*' section and add appropriate persons.
    - Add files missing from 'd/copyright' with appropriate licenses.
  * 'd/rules': Add hardening 'all'.
  * 'd/upstream/metadata':
    - Update 'Bug-Database' link to applications GitLab issue section.
    - Update 'Repository' link to application GitLab code repository.

 -- Phil Wyett <philip.wyett@kathenas.org>  Wed, 16 Oct 2024 21:51:27 +0100
